;#########################################################################
;		Assembler directives

.486
.model flat,stdcall
option casemap:none

;#########################################################################
;		Include file

include ResourceID.inc

.code

;#########################################################################
;		Common AddIn Procedures

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD

	mov		eax,hInst
	mov		hInstance,eax
	mov		eax,TRUE
	ret

DllEntry Endp

InstallDll proc uses ebx,hWin:DWORD,fOpt:DWORD

	mov		ebx,hWin
	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0;	
	mov		lpHandles,eax
	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov		lpProc,eax
	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0	
	mov		lpData,eax
	; Messages to hook into
	mov		eax,RAM_MAKEBEGIN
	; ECX and EDX must be null before we return
	xor		ecx,ecx
	xor		edx,edx
	ret 

InstallDll Endp

ExportFileName proc uses esi,lpFile:DWORD

	mov		esi,lpFile
	invoke lstrlen,esi
	.while eax
		.break .if byte ptr [esi+eax-1]=='\'
		dec		eax
	.endw
	lea		esi,[esi+eax]
	mov		eax,lpData
	mov		eax,[eax].ADDINDATA.nAsm
	.if eax==1 || eax==2 || eax==3 || eax==4 || eax==5
		; masm, tasm, fasm, nasm, goasm
		mov		byte ptr [edi],';'
		inc		edi
	.elseif eax==6 || eax==7
		; hla, cpp
		mov		word ptr [edi],'//'
		add		edi,2
	.elseif eax==8
		; bcet
		mov		byte ptr [edi],"'"
		inc		edi
	.else
		mov		byte ptr [edi],';'
		inc		edi
	.endif
	.while byte ptr [esi]
		mov		al,[esi]
		mov		[edi],al
		inc		esi
		inc		edi
	.endw
	mov		word ptr [edi],0A0Dh
	add		edi,2
	ret

ExportFileName endp

ExportLine proc

	mov		eax,lpData
	mov		eax,[eax].ADDINDATA.nAsm
	.if eax==1 || eax==2 || eax==3 || eax==4 || eax==5
		; Skip #define
		.while byte ptr [esi]!=' ' && byte ptr [esi]!=VK_TAB && byte ptr [esi]
			inc		esi
		.endw
		; Skip whitespace
		.while byte ptr [esi]==' ' || byte ptr [esi]==VK_TAB
			inc		esi
		.endw
		; Copy name
		.while byte ptr [esi]!=' ' && byte ptr [esi]!=VK_TAB && byte ptr [esi]
			mov		al,[esi]
			mov		[edi],al
			inc		esi
			inc		edi
		.endw
		mov		dword ptr [edi],'uqe '
		add		edi,4
		mov		byte ptr [edi],' '
		inc		edi
		; Skip whitespace
		.while byte ptr [esi]==' ' || byte ptr [esi]==VK_TAB
			inc		esi
		.endw
		; Copy ID
		.while byte ptr [esi]!=' ' && byte ptr [esi]!=VK_TAB && byte ptr [esi]!=VK_RETURN && byte ptr [esi]
			mov		al,[esi]
			mov		[edi],al
			inc		esi
			inc		edi
		.endw
	.elseif eax==6
		; hla
		; Skip #define
		.while byte ptr [esi]!=' ' && byte ptr [esi]!=VK_TAB && byte ptr [esi]
			inc		esi
		.endw
		; Skip whitespace
		.while byte ptr [esi]==' ' || byte ptr [esi]==VK_TAB
			inc		esi
		.endw
		; Copy name
		.while byte ptr [esi]!=' ' && byte ptr [esi]!=VK_TAB && byte ptr [esi]
			mov		al,[esi]
			mov		[edi],al
			inc		esi
			inc		edi
		.endw
		mov		dword ptr [edi],' =: '
		add		edi,4
		; Skip whitespace
		.while byte ptr [esi]==' ' || byte ptr [esi]==VK_TAB
			inc		esi
		.endw
		; Copy ID
		.while byte ptr [esi]!=' ' && byte ptr [esi]!=VK_TAB && byte ptr [esi]!=VK_RETURN && byte ptr [esi]
			mov		al,[esi]
			mov		[edi],al
			inc		esi
			inc		edi
		.endw
		mov		byte ptr [edi],';'
		inc		edi
	.elseif eax==7
		; cpp
		.while byte ptr [esi] && byte ptr [esi]!=0Dh
			mov		al,[esi]
			mov		[edi],al
			inc		esi
			inc		edi
		.endw
	.elseif eax==8
		;bcet
		.while byte ptr [esi] && byte ptr [esi]!=0Dh
			mov		al,[esi]
			mov		[edi],al
			inc		esi
			inc		edi
		.endw
	.else
	.endif
	mov		word ptr [edi],0A0Dh
	add		edi,2
	ret

ExportLine endp

ExportFile proc uses esi edi,lpMem:DWORD,lpFile:DWORD
	LOCAL	hFile:DWORD
	LOCAL	hMem:DWORD
	LOCAL	dwRead:DWORD

	invoke CreateFile,lpFile,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
	.if eax!=INVALID_HANDLE_VALUE
		mov		hFile,eax
		invoke GetFileSize,hFile,NULL
		push	eax
		inc		eax
		invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
		mov		hMem,eax
		pop		edx
		invoke ReadFile,hFile,hMem,edx,addr dwRead,NULL
		invoke CloseHandle,hFile
		mov		edi,lpMem
		invoke lstrlen,edi
		lea		edi,[edi+eax]
		invoke ExportFileName,lpFile
		mov		esi,hMem
	  @@:
		push	TRUE	;Whole word
		push	FALSE	;Match case
		push	offset Define
		push	esi
		mov		eax,lpProc
		call	[eax].ADDINPROCS.lpSearchMem
		.if eax
			mov		esi,eax
			invoke ExportLine
			jmp		@b
		.endif
		invoke GlobalFree,hMem
	.endif
	ret

ExportFile endp

FindFiles proc lpMem:DWORD,lpPath:DWORD
	LOCAL	buffer[MAX_PATH]:BYTE
	LOCAL	wfd:WIN32_FIND_DATA
	LOCAL	hwfd:DWORD

	invoke lstrcpy,addr buffer,lpPath
	invoke lstrcat,addr buffer,addr FileSearch
	invoke FindFirstFile,addr buffer,addr wfd
	.if eax!=INVALID_HANDLE_VALUE
		;Save returned handle
		mov		hwfd,eax
	  Next:
		invoke lstrcpy,addr buffer,lpPath
		invoke lstrcat,addr buffer,addr wfd.cFileName
		invoke ExportFile,lpMem,addr buffer
		;Any more matches?
		invoke FindNextFile,hwfd,addr wfd
		or		eax,eax
		jne		Next
		;No more matches, close handle
		invoke FindClose,hwfd
	.endif
	ret

FindFiles endp

Export proc
	LOCAL	buffer[MAX_PATH]:BYTE
	LOCAL	hMem:DWORD
	LOCAL	hFile:DWORD
	LOCAL	dwWrite:DWORD

	invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,64*1024
	mov		hMem,eax
	mov		eax,lpData
	invoke lstrcpy,addr buffer,[eax].ADDINDATA.lpProjectPath
	invoke FindFiles,hMem,addr buffer
	invoke lstrcat,addr buffer,addr ResPath
	invoke FindFiles,hMem,addr buffer
	invoke lstrlen,hMem
	.if eax
		push	eax
		mov		eax,lpData
		invoke lstrcpy,addr buffer,[eax].ADDINDATA.lpProjectPath
		invoke lstrcat,addr buffer,addr FileName
		invoke CreateFile,addr buffer,GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
		mov		hFile,eax
		pop		edx
		invoke WriteFile,hFile,hMem,edx,addr dwWrite,NULL
		invoke CloseHandle,hFile
	.endif
	invoke GlobalFree,hMem
	ret

Export endp

DllProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	buffer[MAX_PATH]:BYTE

	mov		eax,uMsg
	.if eax==AIM_MAKEBEGIN
		mov		eax,lpData
		.if [eax].ADDINDATA.fResChanged
			invoke Export
		.else
			invoke lstrcpy,addr buffer,[eax].ADDINDATA.lpProjectPath
			invoke lstrcat,addr buffer,addr FileName
			invoke GetFileAttributes,addr buffer
			.if eax==INVALID_HANDLE_VALUE
				invoke Export
			.endif
		.endif
	.endif
	mov		eax,FALSE
	ret

DllProc Endp

;#########################################################################

End DllEntry
